package com.nokia.service;

import com.nokia.dao.UserDao;
import com.nokia.pojo.Role;
import com.nokia.pojo.User;
import com.nokia.vo.flow.FlowRoleVo;
import com.nokia.vo.flow.FlowUserVo;
import com.nokia.vo.flow.UserTreeReq;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class FlowService {

    private final UserDao userDao;

    @Autowired
    public FlowService(UserDao userDao) {
        this.userDao = userDao;
    }

    public List<FlowRoleVo> findRoleList(String username) {
        return userDao.findRoleList(username);
    }

    public List<FlowRoleVo> findRoleList() {
        return userDao.findRoleList2();
    }

    public List<FlowUserVo> findToPage() {
        return userDao.findToPage();
    }

    public FlowUserVo getByLoginId(String loginId) {
        return userDao.getFlowUserVoByLoginId(loginId);
    }

    public FlowUserVo getByUserId(Integer userId) {
        return userDao.getFlowUserVoByUserId(userId);
    }

    public List<Integer> findRoleIdByUserId(Integer userId) {
        return userDao.findRoleIdByUserId(userId);
    }

    public List<Integer> findUserIdByRoleId(Integer roleId) {
        return userDao.findUserIdByRoleId(roleId);
    }

    public List<FlowUserVo> findAuthorizedUser(String loginId, Integer roleId, String userName) {
        return userDao.findAuthorizedUser(loginId, roleId, userName);
    }

    public List<Role> getRoleCityByUserId(Integer userId) {
        return userDao.getRoleCityByUserId(userId);
    }

    public Map<String, Object> getUserTree(UserTreeReq userTreeReq) {
        List<Integer> cityIds = new ArrayList<>();
        if (userTreeReq.getCity() == -1) {
            cityIds = null;
        } else {
            cityIds.add(-1);
            cityIds.add(userTreeReq.getCity());
        }
        List<User> users = userDao.getByRoleIds(userTreeReq.getRole(), cityIds);
        Map<String, Object> result = new HashMap<>();
        return result;
    }
}
